import { exist } from '../../support/cypress.util';

export class BenutzerE2EComponent {
  private readonly benutzerHinzufuegenButton: string = 'add-user-button';
  private readonly userEntry: string = 'user-entry-';

  public getHinzufuegenButton(): Cypress.Chainable<Element> {
    return cy.getTestElement(this.benutzerHinzufuegenButton);
  }

  public addUser(): void {
    this.getHinzufuegenButton().click();
  }

  public getUserEntry(user: string): Cypress.Chainable<Element> {
    user = this.userEntry + user;
    return cy.getTestElement(user);
  }

  public stringExistsInUserEntry(phrase: string, user: string): void {
    this.getUserEntry(user).within(() => {
      exist(cy.contains(phrase));
    });
  }
}
