import { haveValue, typeText } from '../../support/cypress.util';

export class PostfachE2EComponent {
  private readonly signaturText: string = 'signature-textarea';
  private readonly saveSignaturButton: string = 'save-button';

  public getSignaturText(): any {
    return cy.getTestElement(this.signaturText);
  }

  public setSignatur(signatur: string): void {
    typeText(this.getSignaturText(), signatur);
  }

  public clearSignatur(): void {
    this.getSignaturText().type('{selectAll}{del}');
  }

  public getSaveButton(): Cypress.Chainable<Element> {
    return cy.getTestElement(this.saveSignaturButton);
  }

  public saveSignatur(): void {
    this.getSaveButton().click();
  }

  public signatureIs(compare: string): void {
    haveValue(this.getSignaturText(), compare);
  }

  public scrollbarIsPresent(): void {
    this.getSignaturText().then((textarea) => {
      const scrollHeight = textarea[0].scrollHeight;
      const clientHeight = textarea[0].clientHeight;

      expect(scrollHeight).to.be.greaterThan(clientHeight);
    });
  }
}
