import { BenutzerE2EComponent } from '../../components/benutzer/benutzer.e2e.component';
import { MainPage } from '../../page-objects/main.po';
import { exist } from '../../support/cypress.util';
import { loginAsAriane } from '../../support/user-util';

const mainPage: MainPage = new MainPage();
const benutzerPage: BenutzerE2EComponent = new BenutzerE2EComponent();
const role1: string = 'VERWALTUNG_USER';
const role2: string = 'VERWALTUNG_LOESCHEN';
const role3: string = 'VERWALTUNG_POSTSTELLE';
const orga1: string = 'Ordnungsamt';
const orga2: string = 'Landesamt für Denkmalpflege';
const orga3: string = 'Wirtschaftsförderung';
const orga_none: string = 'keine zuständige Stelle zugewiesen';
const mail1: string = 'peter.von.der.post@ozg-sh.de';

describe('Benutzer und Rollen', () => {
  before(() => {
    loginAsAriane();
  });

  it('should open Benutzer tab and show Hinzufuegen button', () => {
    mainPage.clickBenutzerTab();

    exist(benutzerPage.getHinzufuegenButton());
  });

  it('should show users and attributes in table', () => {
    exist(benutzerPage.getUserEntry('ariane'));
    benutzerPage.stringExistsInUserEntry(role1, 'dorothea');
    benutzerPage.stringExistsInUserEntry(orga1, 'ludwig');
    benutzerPage.stringExistsInUserEntry(role1, 'zelda');
    benutzerPage.stringExistsInUserEntry(role2, 'zelda');
    benutzerPage.stringExistsInUserEntry(orga2, 'zelda');
    benutzerPage.stringExistsInUserEntry(orga3, 'zelda');
    benutzerPage.stringExistsInUserEntry(orga_none, 'adelheit');
    benutzerPage.stringExistsInUserEntry(mail1, 'peter');
    benutzerPage.stringExistsInUserEntry(role3, 'peter');
  });
});
