// ***********************************************************
// This example support/index.js is processed and
// loaded automatically before your test files.
//
// This is a great place to put global configuration and
// behavior that modifies Cypress.
//
// You can change the location of this file or turn off
// automatically serving support files with the
// 'supportFile' configuration option.
//
// You can read more here:
// https://on.cypress.io/configuration
// ***********************************************************

// Import commands.js using ES2015 syntax:
import 'cypress-mochawesome-reporter/register';
import 'cypress-real-events';
import 'cypress-timestamps/support';
import './commands';

Cypress.on('command:start', ({ attributes }) => {
  if (attributes.type === 'parent') {
    Cypress.log({
      name: `${new Date().toISOString()} - ${attributes.name}`,
    });
  }
});

Cypress.on('after:screenshot', ({ testFailure, takenAt }) => {
  if (testFailure) {
    console.log(`Error at: ${takenAt}`);
  }
});

Cypress.on('fail', (err) => {
  console.error(err);
  err.message = new Date().toISOString() + '\n' + err.message;
  throw err;
});

Cypress.Keyboard.defaults({
  keystrokeDelay: 30,
});
