import { AdminOrganisationsEinheitResource } from '@admin-client/admin-settings';
import { ApiResourceService, ResourceRepository, ResourceServiceConfig } from '@alfa-client/tech-shared';
import { ConfigurationResource } from 'libs/admin/settings/src/lib/configuration/configuration.model';
import { OrganisationsEinheitListResourceService } from './organisations-einheit-list-resource.service';
import { OrganisationsEinheitLinkRel } from './organisations-einheit.linkrel';

export class OrganisationsEinheitResourceService extends ApiResourceService<
  AdminOrganisationsEinheitResource,
  AdminOrganisationsEinheitResource
> {}

export function createOrganisationsEinheitResourceService(
  repository: ResourceRepository,
  listResourceService: OrganisationsEinheitListResourceService,
) {
  return new ApiResourceService(buildConfig(listResourceService), repository);
}

function buildConfig(listResourceService: OrganisationsEinheitListResourceService): ResourceServiceConfig<ConfigurationResource> {
  return {
    resource: listResourceService.getSelected(),
    getLinkRel: OrganisationsEinheitLinkRel.SELF,
    edit: { linkRel: OrganisationsEinheitLinkRel.SELF },
  };
}
