import { AdminOrganisationsEinheitResource, AdminOrganisationsEinheitSyncResult } from '@admin-client/admin-settings';
import { Component, Input } from '@angular/core';

@Component({
  selector: 'admin-organisationseinheit-list',
  templateUrl: './organisationseinheit-list.component.html',
})
export class OrganisationsEinheitListComponent {
  private _organisationsEinheitResources: AdminOrganisationsEinheitResource[] = [];

  @Input()
  public get organisationsEinheitResources(): AdminOrganisationsEinheitResource[] {
    return this._organisationsEinheitResources;
  }

  public set organisationsEinheitResources(list: AdminOrganisationsEinheitResource[]) {
    this.moveChildrenIntoParentLevel(list);
  }

  public readonly AdminOrganisationsEinheitSyncResult = AdminOrganisationsEinheitSyncResult;

  moveChildrenIntoParentLevel(list: AdminOrganisationsEinheitResource[]): void {
    list.forEach((parent: AdminOrganisationsEinheitResource) => {
      this._organisationsEinheitResources.push(parent);

      if (parent._embedded && Array.isArray(parent._embedded.childList)) {
        parent._embedded.childList.forEach((child: AdminOrganisationsEinheitResource) => {
          child.isChild = true;
          this._organisationsEinheitResources.push(child);
        });
      }
    });
  }
}
