import { StateResource } from '@alfa-client/tech-shared';
import { Component, OnInit } from '@angular/core';
import { Observable } from 'rxjs';
import { OrganisationsEinheitListLinkRel } from '../organisations-einheit.linkrel';
import { AdminOrganisationsEinheitResource } from '../organisations-einheit.model';
import { OrganisationsEinheitService } from '../organisationseinheit.service';

@Component({
  selector: 'admin-organisationseinheit-form-container',
  templateUrl: './organisationseinheit-form-container.component.html',
})
export class OrganisationsEinheitFormContainerComponent implements OnInit {
  organisationsEinheitStateResource$: Observable<StateResource<AdminOrganisationsEinheitResource>>;

  constructor(private organisationsEinheitService: OrganisationsEinheitService) {}

  ngOnInit(): void {
    this.organisationsEinheitStateResource$ = this.organisationsEinheitService.get();
  }

  protected readonly OrganisationsEinheitListLinkRel = OrganisationsEinheitListLinkRel;
}
