import { NavigationSharedModule } from '@alfa-client/navigation-shared';
import { getElementFromFixture, mock, useFromMock } from '@alfa-client/test-utils';
import { ComponentFixture, TestBed } from '@angular/core/testing';
import { FormBuilder, ReactiveFormsModule } from '@angular/forms';
import { EffectsModule } from '@ngrx/effects';
import { StoreModule } from '@ngrx/store';
import { TextareaEditorComponent } from '@ods/component';
import { MockComponent } from 'ng-mocks';
import { getDataTestIdOf } from '../../../../../../../../tech-shared/test/data-test';
import { OrganisationsEinheitService } from '../../../organisationseinheit.service';
import { OrganisationsEinheitFormService } from '../organisationseinheit.formservice';
import { OrganisationsEinheitSignaturComponent } from './organisationseinheit-signatur.component';

describe('OrganisationsEinheitSignaturComponent', () => {
  let component: OrganisationsEinheitSignaturComponent;
  let fixture: ComponentFixture<OrganisationsEinheitSignaturComponent>;
  let formService: OrganisationsEinheitFormService;

  const signaturTextareaSelector: string = getDataTestIdOf('signatur-text');

  beforeEach(async () => {
    formService = new OrganisationsEinheitFormService(new FormBuilder(), useFromMock(mock(OrganisationsEinheitService)));

    await TestBed.configureTestingModule({
      imports: [ReactiveFormsModule, NavigationSharedModule, StoreModule.forRoot({}), EffectsModule.forRoot([])],
      declarations: [OrganisationsEinheitSignaturComponent, MockComponent(TextareaEditorComponent)],
      providers: [
        {
          provide: OrganisationsEinheitFormService,
          useValue: formService,
        },
      ],
    }).compileComponents();

    fixture = TestBed.createComponent(OrganisationsEinheitSignaturComponent);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });

  describe('template', () => {
    describe('ods-textarea-editor', () => {
      describe('input', () => {
        it('should set signatur field', () => {
          const textAreaEditor: HTMLElement = getElementFromFixture(fixture, signaturTextareaSelector);

          expect(textAreaEditor.getAttribute('rows')).toEqual('6');
        });
      });
    });
  });
});
