import {
  ApiResourceService,
  ResourceRepository,
  ResourceServiceConfig,
} from '@alfa-client/tech-shared';
import { SettingsService } from '../admin-settings.service';
import { PostfachLinkRel } from './postfach.linkrel';
import { PostfachResource } from './postfach.model';

export class PostfachResourceService extends ApiResourceService<
  PostfachResource,
  PostfachResource
> {}

export function createPostfachResourceService(
  repository: ResourceRepository,
  settingService: SettingsService,
) {
  return new ApiResourceService(buildConfig(settingService), repository);
}

function buildConfig(settingService: SettingsService): ResourceServiceConfig<PostfachResource> {
  return {
    resource: settingService.getPostfach(),
    getLinkRel: PostfachLinkRel.SELF,
    edit: { linkRel: PostfachLinkRel.SELF },
  };
}
