import { Injectable } from '@angular/core';
import { map, Observable } from 'rxjs';
import { KeycloakResourceService } from '../user/keycloak.resource.service';
import { User } from '../user/user.model';
import { UserRepository } from '../user/user.repository.service';
import { sortUsersByLastName } from '../user/user.util';

@Injectable({
  providedIn: 'root',
})
export class UserService extends KeycloakResourceService<User> {
  constructor(private userRepository: UserRepository) {
    super();
  }

  getItemsFromKeycloak(): Observable<User[]> {
    return this.userRepository.getUsers().pipe(map(sortUsersByLastName));
  }

  createInKeycloak(item: Partial<User>): Observable<User> {
    throw new Error('Method not implemented.');
  }

  saveInKeycloak(item: User): Observable<void> {
    throw new Error('Method not implemented.');
  }

  deleteInKeycloak(id: string): Observable<void> {
    throw new Error('Method not implemented.');
  }
}
