import { Mock, mock } from '@alfa-client/test-utils';
import { ComponentFixture, TestBed } from '@angular/core/testing';
import { ButtonWithSpinnerComponent } from '@ods/component';
import { MailboxIconComponent, PersonIconComponent } from '@ods/system';
import { MockComponent, MockPipe } from 'ng-mocks';
import { ToUserNamePipe } from '../user/to-user-name.pipe';
import { UserService } from './user.service';
import { UsersRolesComponent } from './users-roles.component';

describe('UsersRolesComponent', () => {
  let component: UsersRolesComponent;
  let fixture: ComponentFixture<UsersRolesComponent>;

  const userService: Mock<UserService> = {
    ...mock(UserService),
    get: jest.fn(),
  };

  beforeEach(async () => {
    await TestBed.configureTestingModule({
      declarations: [UsersRolesComponent],
      providers: [{ provide: UserService, useValue: userService }],
      imports: [
        MockComponent(ButtonWithSpinnerComponent),
        MockComponent(MailboxIconComponent),
        MockComponent(PersonIconComponent),
        MockPipe(ToUserNamePipe),
      ],
    }).compileComponents();

    fixture = TestBed.createComponent(UsersRolesComponent);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });

  describe('template', () => {
    it('should create', () => {
      expect(component).toBeTruthy();
    });

    describe('constructor', () => {
      it('should call userService.get', () => {
        expect(userService.get).toHaveBeenCalled();
      });
    });
  });
});
