import { ApiDownloadToken, ApiRootService } from '@alfa-client/api-root-shared';
import { BinaryFileResource, BinaryFileService } from '@alfa-client/binary-file-shared';
import { StateResource } from '@alfa-client/tech-shared';
import { Component, EventEmitter, Input, Output } from '@angular/core';
import { Observable } from 'rxjs';

@Component({
  selector: 'alfa-binary-file2-container',
  templateUrl: './binary-file2-container.component.html',
})
export class BinaryFile2ContainerComponent {
  @Input() file: BinaryFileResource;
  @Input() downloadFileNamePrefix: string;
  @Input() deletable: boolean = false;

  @Output() startDelete: EventEmitter<BinaryFileResource> = new EventEmitter();

  fileStateResource$: Observable<StateResource<any>>;
  downloadToken$: Observable<ApiDownloadToken>;

  constructor(
    private binaryFileService: BinaryFileService,
    private apiRootService: ApiRootService,
  ) {}

  startDownload(file: BinaryFileResource): void {
    this.fileStateResource$ = this.binaryFileService.downloadFile(
      file,
      this.downloadFileNamePrefix,
    );
  }

  getDownloadToken(): void {
    this.downloadToken$ = this.apiRootService.getDownloadToken(this.file);
  }
}
