import { dispatchEventFromFixture } from '@alfa-client/test-utils';
import { ComponentFixture, TestBed } from '@angular/core/testing';
import { ButtonComponent, UsersIconComponent } from '@ods/system';
import { getDataTestIdAttributeOf } from 'libs/tech-shared/test/data-test';
import { MockComponent } from 'ng-mocks';
import { AnfrageErstellenButtonComponent } from './anfrage-erstellen-button.component';

describe('AnfrageErstellenButtonComponent', () => {
  let component: AnfrageErstellenButtonComponent;
  let fixture: ComponentFixture<AnfrageErstellenButtonComponent>;

  const button: string = getDataTestIdAttributeOf('anfrage-erstellen-button');

  beforeEach(async () => {
    await TestBed.configureTestingModule({
      declarations: [AnfrageErstellenButtonComponent],
      imports: [MockComponent(ButtonComponent), MockComponent(UsersIconComponent)],
    }).compileComponents();

    fixture = TestBed.createComponent(AnfrageErstellenButtonComponent);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });

  describe('click on button', () => {
    it('should emit', () => {
      component.clickEmitter.emit = jest.fn();

      dispatchEventFromFixture(fixture, button, 'clickEmitter');

      expect(component.clickEmitter.emit).toHaveBeenCalled();
    });
  });
});
