import { CollaborationSharedModule } from '@alfa-client/collaboration-shared';
import { TechSharedModule } from '@alfa-client/tech-shared';
import { ZustaendigeStelleModule } from '@alfa-client/zustaendige-stelle';
import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { ButtonWithSpinnerComponent, TextEditorComponent, TextareaEditorComponent } from '@ods/component';
import {
  ButtonComponent,
  CloseIconComponent,
  ExternalUnitIconComponent,
  OfficeIconComponent,
  PublicAdministrationIconComponent,
  SaveIconComponent,
  SearchIconComponent,
  UsersIconComponent,
} from '@ods/system';
import { CollaborationInVorgangContainerComponent } from './collaboration-in-vorgang-container/collaboration-in-vorgang-container.component';
import { AnfrageErstellenButtonComponent } from './collaboration-in-vorgang-container/collaboration-in-vorgang/anfrage-erstellen-button/anfrage-erstellen-button.component';
import { CollaborationInVorgangComponent } from './collaboration-in-vorgang-container/collaboration-in-vorgang/collaboration-in-vorgang.component';
import { ExterneFachstelleContainerComponent } from './collaboration-in-vorgang-container/collaboration-in-vorgang/externe-fachstelle-container/externe-fachstelle-container.component';
import { OrganisationsEinheitContainerComponent } from './collaboration-in-vorgang-container/collaboration-in-vorgang/organisations-einheit-container/organisations-einheit-container.component';
import { CollaborationRequestFormComponent } from './collaboration-in-vorgang-container/collaboration-request-form/collaboration-request-form.component';

@NgModule({
  imports: [
    CommonModule,
    ButtonComponent,
    SaveIconComponent,
    CloseIconComponent,
    SearchIconComponent,
    CollaborationSharedModule,
    UsersIconComponent,
    TextEditorComponent,
    TextareaEditorComponent,
    FormsModule,
    ReactiveFormsModule,
    TechSharedModule,
    ButtonWithSpinnerComponent,
    ZustaendigeStelleModule,
    OfficeIconComponent,
    ExternalUnitIconComponent,
    PublicAdministrationIconComponent,
  ],
  declarations: [
    CollaborationInVorgangContainerComponent,
    CollaborationInVorgangComponent,
    CollaborationRequestFormComponent,
    AnfrageErstellenButtonComponent,
    OrganisationsEinheitContainerComponent,
    ExterneFachstelleContainerComponent,
  ],
  exports: [CollaborationInVorgangContainerComponent],
})
export class CollaborationModule {}
