import { CommonModule } from '@angular/common';
import { Component, EventEmitter, Input, Output } from '@angular/core';

@Component({
  selector: 'ods-dropdown-menu-button',
  standalone: true,
  imports: [CommonModule],
  template: `<button
    class="flex min-h-12 w-full items-center gap-4 border-2 border-transparent px-4 py-3
    text-start outline-none hover:border-primary focus-visible:border-focus"
    role="menuitem"
    (click)="itemClicked.emit()"
  >
    <ng-content select="[icon]" />
    <p class="text-text">{{ caption }}</p>
  </button>`,
})
export class DropdownMenuButtonComponent {
  @Input({ required: true }) caption!: string;

  @Output() itemClicked: EventEmitter<MouseEvent> = new EventEmitter();
}
