import { moduleMetadata, type Meta, type StoryObj } from '@storybook/angular';

import { ButtonToggleComponent } from './button-toggle.component';

const meta: Meta<ButtonToggleComponent> = {
  title: 'Button toggle',
  component: ButtonToggleComponent,
  parameters: {
    docs: {
      description: {
        component: 'A button for toggling state',
      },
    },
  },
  decorators: [
    moduleMetadata({
      imports: [ButtonToggleComponent],
    }),
  ],
  excludeStories: /.*Data$/,
  tags: ['autodocs'],
};

export default meta;
type Story = StoryObj<ButtonToggleComponent>;

export const Default: Story = {
  args: {
    label: 'button toggle',
  },
  argTypes: {
    label: { description: 'Label for button' },
  },
};
