import { argsToTemplate, moduleMetadata, type Meta, type StoryObj } from '@storybook/angular';
import { ErrorMessageComponent } from './error-message.component';

const meta: Meta<ErrorMessageComponent> = {
  title: 'Error message',
  component: ErrorMessageComponent,
  decorators: [
    moduleMetadata({
      imports: [ErrorMessageComponent],
    }),
  ],
  excludeStories: /.*Data$/,
  tags: ['autodocs'],
};

export default meta;
type Story = StoryObj<ErrorMessageComponent>;

export const Default: Story = {
  args: {
    text: 'Ein Fehler ist aufgetreten.',
    subText: 'Versuchen Sie es nocheinmal.',
  },
  argTypes: {
    text: { description: 'First line of text' },
    subText: { description: 'Second line of text' },
  },
  render: (args: ErrorMessageComponent) => ({
    props: args,
    template: `<ods-error-message ${argsToTemplate(args)} class="w-72">
      </ods-error-message>`,
  }),
};
