import { TechSharedModule } from '@alfa-client/tech-shared';
import { getElementFromFixture } from '@alfa-client/test-utils';
import { ComponentFixture, TestBed } from '@angular/core/testing';
import { faker } from '@faker-js/faker';
import { getDataTestIdOf } from 'libs/tech-shared/test/data-test';
import { FileUploadButtonComponent } from './file-upload-button.component';

describe('FileUploadButtonComponent', () => {
  let component: FileUploadButtonComponent;
  let fixture: ComponentFixture<FileUploadButtonComponent>;

  const labelText: string = faker.word.noun();
  const inputTestClass: string = getDataTestIdOf(labelText + '-file-upload-input');

  beforeEach(async () => {
    await TestBed.configureTestingModule({
      imports: [FileUploadButtonComponent, TechSharedModule],
    }).compileComponents();

    fixture = TestBed.createComponent(FileUploadButtonComponent);
    component = fixture.componentInstance;
    component.id = labelText;
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });

  describe('click at file input', () => {
    it('should call resetInput()', () => {
      component.resetInput = jest.fn();
      const fileInput = getElementFromFixture(fixture, inputTestClass);

      fileInput.click();
      fixture.detectChanges();

      expect(component.resetInput).toHaveBeenCalled();
    });
  });
});
