import type { Meta, StoryObj } from '@storybook/angular';

import { EditIconComponent } from './edit-icon.component';

const meta: Meta<EditIconComponent> = {
  title: 'Icons/Edit icon',
  component: EditIconComponent,
  excludeStories: /.*Data$/,
  tags: ['autodocs'],
};

export default meta;
type Story = StoryObj<EditIconComponent>;

export const Default: Story = {
  args: { size: 'medium' },
  argTypes: {
    size: {
      control: 'select',
      options: ['small', 'medium', 'large', 'extra-large', 'full'],
      description: 'Size of icon. Property "full" means 100%',
      table: {
        defaultValue: { summary: 'medium' },
      },
    },
  },
};
