import type { Meta, StoryObj } from '@storybook/angular';

import { PersonIconComponent } from './person-icon.component';

const meta: Meta<PersonIconComponent> = {
  title: 'Icons/Person icon',
  component: PersonIconComponent,
  excludeStories: /.*Data$/,
  tags: ['autodocs'],
};

export default meta;
type Story = StoryObj<PersonIconComponent>;

export const Default: Story = {
  args: { size: 'large' },
  argTypes: {
    size: {
      control: 'select',
      options: ['small', 'medium', 'large', 'extra-large', 'full'],
      description: 'Size of icon. Property "full" means 100%',
      table: {
        defaultValue: { summary: 'small' },
      },
    },
  },
};
