import { APP_BASE_HREF } from '@angular/common';
import { importProvidersFrom } from '@angular/core';
import { RouterModule } from '@angular/router';
import { applicationConfig, moduleMetadata, type Meta, type StoryObj } from '@storybook/angular';
import { ListItemComponent } from './list-item/list-item.component';
import { ListComponent } from './list.component';

const meta: Meta<ListComponent> = {
  title: 'List',
  component: ListComponent,
  excludeStories: /.*Data$/,
  tags: ['autodocs'],
  decorators: [
    applicationConfig({
      providers: [importProvidersFrom(RouterModule.forRoot([]))],
    }),
    moduleMetadata({
      imports: [ListItemComponent],
      providers: [
        {
          provide: APP_BASE_HREF,
          useValue: '/',
        },
      ],
    }),
  ],
};

export default meta;
type Story = StoryObj<ListComponent>;

export const Default: Story = {
  args: {},
  render: () => ({
    template: `
      <ods-list>
        <ods-list-item path="/pfad/1">List Item 1</ods-list-item>
        <ods-list-item path="/pfad/2">List Item 2</ods-list-item>
        <ods-list-item path="/pfad/3">List Item 3</ods-list-item>
      </ods-list>`,
  }),
};
