/*
 * Copyright (C) 2023 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
import { Component, Input } from '@angular/core';
import { CommandOrder, CommandResource } from '@alfa-client/command-shared';

@Component({
  selector: 'alfa-historie-item-loesch-anforderung',
  templateUrl: './historie-item-loesch-anforderung.component.html',
  styleUrls: ['./historie-item-loesch-anforderung.component.scss'],
})
export class HistorieItemLoeschAnforderungComponent {
  @Input() command: CommandResource;

  headline: string;

  ngOnInit(): void {
    this.headline = HISTORIE_TEXT_BY_COMMAND_ORDER[this.command.order];
  }
}

const HISTORIE_TEXT_BY_COMMAND_ORDER: { [order: string]: string } = {
  [CommandOrder.VORGANG_ZUM_LOESCHEN_MARKIEREN]: 'eine Löschanforderung gestellt.',
  [CommandOrder.LOESCH_ANFORDERUNG_ZURUECKNEHMEN]: 'die Löschanforderung zurückgenommen.',
};
