/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
import { faker } from '@faker-js/faker';
import { toResource } from 'libs/tech-shared/test/resource';
import { times } from 'lodash-es';
import { KommentarListLinkRel } from '../src/lib/kommentar.linkrel';
import { Kommentar, KommentarListResource, KommentarResource } from '../src/lib/kommentar.model';

export function createKommentar(): Kommentar {
  return {
    text: faker.word.sample(10),
    createdAt: faker.date.past(),
    createdBy: faker.word.sample(2),
    attachments: [],
  };
}

export function createKommentarResource(linkRel: string[] = []): KommentarResource {
  return toResource(createKommentar(), linkRel);
}

export function createKommentarResources(linkRel: string[] = []): KommentarResource[] {
  return times(10, () => createKommentarResource(linkRel));
}

export function createKommentarListResource(linkRel: string[] = []): KommentarListResource {
  return toResource({}, [...linkRel], {
    [KommentarListLinkRel.KOMMENTAR_LIST]: createKommentarResources(),
  });
}
