import { Resource } from '@ngxp/rest';
import { createDummyResource } from 'libs/tech-shared/test/resource';
import { NotHasAnyLinkPipe } from './not-has-any-link.pipe';

import * as TechUtil from '../tech.util';

describe('NotHasAnyLinkPipe', () => {
  const oneLink: string = 'one';
  const anotherLink: string = 'another';
  const resource: Resource = createDummyResource([oneLink, anotherLink]);
  const pipe: NotHasAnyLinkPipe = new NotHasAnyLinkPipe();

  describe('transform', () => {
    let notHasAnyLinkSpy: jest.SpyInstance<boolean>;

    beforeEach(() => {
      notHasAnyLinkSpy = jest.spyOn(TechUtil, 'notHasAnyLink').mockReturnValue(true);
    });

    it('should call not has any link', () => {
      pipe.transform(resource, oneLink);

      expect(notHasAnyLinkSpy).toHaveBeenCalledWith(resource, oneLink);
    });

    it('should return value', () => {
      const result: boolean = pipe.transform(resource, oneLink, anotherLink);

      expect(result).toBe(true);
    });
  });
});
