import { ResourceRepository } from '@alfa-client/tech-shared';
import { VorgangService } from '@alfa-client/vorgang-shared';
import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import {
  ExterneFachstelleResourceSearchService,
  createExterneFachstelleResourceSearchService,
} from './externe-fachstelle/externe-fachstelle-resource-search.service';
import { ExterneFachstelleService } from './externe-fachstelle/externe-fachstelle.service';
import {
  OrganisationsEinheitResourceSearchService,
  createOrganisationsEinheitResourceSearchService,
} from './organisations-einheit/organisations-einheit-resource-search.service';
import { OrganisationsEinheitService } from './organisations-einheit/organisations-einheit.service';

@NgModule({
  imports: [CommonModule],
  providers: [
    OrganisationsEinheitService,
    ExterneFachstelleService,
    {
      provide: OrganisationsEinheitResourceSearchService,
      useFactory: createOrganisationsEinheitResourceSearchService,
      deps: [ResourceRepository, VorgangService],
    },
    {
      provide: ExterneFachstelleResourceSearchService,
      useFactory: createExterneFachstelleResourceSearchService,
      deps: [ResourceRepository, VorgangService],
    },
  ],
})
export class ZustaendigeStelleSharedModule {}
