import { faker } from '@faker-js/faker';
import { toResource } from 'libs/tech-shared/test/resource';
import { times } from 'lodash-es';
import { ExterneFachstelleListLinkRel } from '../src/lib/externe-fachstelle/externe-fachstelle.linkrel';
import {
  ExterneFachstelle,
  ExterneFachstelleListResource,
  ExterneFachstelleResource,
} from '../src/lib/externe-fachstelle/externe-fachstelle.model';

export function createExterneFachstelle(): ExterneFachstelle {
  return {
    name: faker.lorem.word(),
    anschrift: faker.lorem.words(5),
    email: faker.internet.email(),
  };
}

export function createExterneFachstelleResource(linkRel: string[] = []): ExterneFachstelleResource {
  return toResource(createExterneFachstelle(), linkRel);
}

export function createExterneFachstelleResources(linkRelations: string[] = []): ExterneFachstelleResource[] {
  return times(10, () => toResource(createExterneFachstelleResource(), [...linkRelations]));
}

export function createExterneFachstelleListResource(
  resources?: ExterneFachstelleResource[],
  linkRelations: string[] = [],
): ExterneFachstelleListResource {
  return toResource({}, [...linkRelations], {
    [ExterneFachstelleListLinkRel.EXTERNE_FACHSTELLE_LIST]: resources ? resources : createExterneFachstelleResources(),
  });
}
