import { faker } from '@faker-js/faker';
import { times } from 'lodash-es';
import { toResource } from '../../tech-shared/test/resource';
import { OrganisationsEinheitListLinkRel } from '../src/lib/organisations-einheit/organisations-einheit.linkrel';
import {
  Anschrift,
  OrganisationsEinheit,
  OrganisationsEinheitListResource,
  OrganisationsEinheitResource,
} from '../src/lib/organisations-einheit/organisations-einheit.model';

export function createAnschrift(): Anschrift {
  return {
    hausnummer: faker.word.sample(),
    ort: faker.word.sample(),
    plz: faker.word.sample(),
    strasse: faker.word.sample(2),
  };
}

export function createOrganisationsEinheit(): OrganisationsEinheit {
  return {
    name: faker.word.sample(),
    anschrift: createAnschrift(),
  };
}

export function createOrganisationsEinheitResource(linkRel: string[] = []): OrganisationsEinheitResource {
  return toResource(createOrganisationsEinheit(), linkRel);
}

export function createOrganisationsEinheitResources(linkRelations: string[] = []): OrganisationsEinheitResource[] {
  return times(10, () => toResource(createOrganisationsEinheitResource(), [...linkRelations]));
}

export function createOrganisationsEinheitListResource(
  resources?: OrganisationsEinheitResource[],
  linkRelations: string[] = [],
): OrganisationsEinheitListResource {
  return toResource({}, [...linkRelations], {
    [OrganisationsEinheitListLinkRel.ORGANISATIONS_EINHEIT_HEADER_LIST]:
      resources ? resources : createOrganisationsEinheitResources(),
  });
}
