import { Anschrift, OrganisationsEinheitResource } from '@alfa-client/zustaendige-stelle-shared';
import { Component, Input } from '@angular/core';

@Component({
  selector: 'alfa-organisations-einheit',
  templateUrl: './organisations-einheit.component.html',
})
export class OrganisationsEinheitComponent {
  @Input() public set organisationsEinheitResource(organisationsEinheit: OrganisationsEinheitResource) {
    this.updateByOrganisationsEinheit(organisationsEinheit);
  }

  public address: string;

  updateByOrganisationsEinheit(organisationsEinheit: OrganisationsEinheitResource): void {
    this.address = this.buildAddress(organisationsEinheit.anschrift);
  }

  private buildAddress(anschrift: Anschrift): string {
    return `${anschrift.strasse} ${anschrift.hausnummer}, ${anschrift.plz} ${anschrift.ort}`;
  }
}
