package de.ozgcloud.alfa.bescheid;

import java.util.List;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.NullValueCheckStrategy;
import org.mapstruct.ReportingPolicy;

import com.google.protobuf.ProtocolStringList;

import de.ozgcloud.alfa.common.binaryfile.FileId;
import de.ozgcloud.alfa.common.binaryfile.FileIdMapper;
import de.ozgcloud.alfa.common.user.UserIdMapper;
import de.ozgcloud.bescheid.GrpcBescheid;
import de.ozgcloud.bescheid.GrpcSentInfo;

@Mapper(unmappedTargetPolicy = ReportingPolicy.ERROR, nullValueCheckStrategy = NullValueCheckStrategy.ALWAYS, uses = { FileIdMapper.class,
		UserIdMapper.class })
interface BescheidMapper {

	@Mapping(target = "attachments", source = "grpcBescheid.attachmentsList")
	Bescheid fromGrpc(GrpcBescheid grpcBescheid, String vorgangId);

	List<FileId> fromProtocolStringList(ProtocolStringList value);

	SentInfo fromGrpcSentInfo(GrpcSentInfo grpcSentInfo);
}
