package de.ozgcloud.alfa.collaboration;

import java.util.Optional;

import org.springframework.hateoas.CollectionModel;
import org.springframework.hateoas.EntityModel;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import lombok.RequiredArgsConstructor;

@RestController
@RequestMapping(FachstelleController.PATH)
@RequiredArgsConstructor
class FachstelleController {

	static final String PATH = "/api/fachstelles"; // NOSONAR
	static final String SEARCH_BY_PARAM = "searchBy";

	private final FachstelleService service;
	private final FachstelleModelAssembler modelAssembler;

	@GetMapping(params = { SEARCH_BY_PARAM })
	public CollectionModel<EntityModel<Fachstelle>> search(@RequestParam String searchBy) {
		return modelAssembler.toCollectionModel(service.searchFachstellen(searchBy).toList());
	}

	@GetMapping("/{id}")
	public ResponseEntity<EntityModel<Fachstelle>> getById(@PathVariable String id) {
		return ResponseEntity.of(Optional.of(service.getById(id)).map(modelAssembler::toModel));
	}
}
