package de.ozgcloud.alfa.export;

import org.springframework.stereotype.Service;

import de.ozgcloud.alfa.common.GrpcUtil;
import de.ozgcloud.archive.grpc.export.ExportServiceGrpc.ExportServiceBlockingStub;
import de.ozgcloud.archive.grpc.export.GrpcExportVorgangRequest;
import net.devh.boot.grpc.client.inject.GrpcClient;

@Service
class ExportRemoteService {

	@GrpcClient(GrpcUtil.ARCHIVE_MANAGER_GRPC_CLIENT)
	private ExportServiceBlockingStub exportServiceStub;

	public ExportedVorgangFile exportVorgang(String vorgangId) {
		var responseIterator = exportServiceStub.exportVorgang(GrpcExportVorgangRequest.newBuilder().setVorgangId(vorgangId).build());
		return new StreamedExportedVorgangFile(responseIterator);
	}
}
