package de.ozgcloud.alfa.export;

import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.mvc.method.annotation.StreamingResponseBody;

import lombok.RequiredArgsConstructor;

@RestController
@RequestMapping(ExportVorgangController.PATH)
@RequiredArgsConstructor
public class ExportVorgangController {

	static final String PATH = "/api/vorgangs"; // NOSONAR

	private final ExportRemoteService exportRemoteService;

	@GetMapping(value = "{vorgangId}", produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	public ResponseEntity<StreamingResponseBody> exportVorgang(@PathVariable String vorgangId) {
		var exportedVorgangFile = exportRemoteService.exportVorgang(vorgangId);
		return ResponseEntity.ok()
				.header(HttpHeaders.CONTENT_DISPOSITION, String.format("attachment; filename=%s", exportedVorgangFile.getFileName()))
				.contentType(MediaType.APPLICATION_OCTET_STREAM)
				.body(exportedVorgangFile::writeToOutputStream);
	}
}
