package de.ozgcloud.alfa.export;

import java.io.IOException;
import java.io.OutputStream;
import java.util.Iterator;

import de.ozgcloud.archive.grpc.export.GrpcExportVorgangResponse;
import de.ozgcloud.common.errorhandling.TechnicalException;
import lombok.Getter;

class StreamedExportedVorgangFile implements ExportedVorgangFile {

	@Getter
	private final String fileName;
	private final Iterator<GrpcExportVorgangResponse> responseIterator;

	public StreamedExportedVorgangFile(Iterator<GrpcExportVorgangResponse> responseIterator) {
		this.fileName = getFileNameFrom(responseIterator);
		this.responseIterator = responseIterator;
	}

	static String getFileNameFrom(Iterator<GrpcExportVorgangResponse> responseIterator) {
		if (!responseIterator.hasNext()) {
			throw new TechnicalException("Response is empty");
		}
		return responseIterator.next().getVorgangFile().getFileName();
	}

	@Override
	public void writeToOutputStream(OutputStream outputStream) throws IOException {
		while (responseIterator.hasNext()) {
			outputStream.write(responseIterator.next().getVorgangFile().getFileContent().toByteArray());
		}
	}
}
