package de.ozgcloud.alfa.common;

import static org.mockito.Mockito.*;

import java.nio.charset.StandardCharsets;
import java.util.HexFormat;
import java.util.List;
import java.util.function.Consumer;
import java.util.stream.Stream;

import org.apache.commons.lang3.RandomStringUtils;

public class AlfaTestUtils {

	public static final String UUID_REGEX = "[0-9a-f]{8,8}-[0-9a-f]{4,4}-[0-9a-f]{4,4}-[0-9a-f]{4,4}-[0-9a-f]{12,12}";

	public static String uuidRegexWithSuffix(String suffix) {
		return String.format("^%s%s$", UUID_REGEX, suffix);
	}

	public static <T> void mockStreamToList(List<T> list, Consumer<Stream<T>> mock) {
		var mockStream = mock(Stream.class);
		when(mockStream.toList()).thenReturn(list);
		mock.accept(mockStream);
	}

	public static String createMongoDbObjectId() {
		return HexFormat.of().formatHex(RandomStringUtils.randomAlphanumeric(24).getBytes(StandardCharsets.UTF_8));
	}

}
