package de.ozgcloud.alfa.common.command;

import static org.assertj.core.api.Assertions.*;
import static org.mockito.Mockito.*;

import jakarta.validation.ConstraintValidatorContext;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mockito.Mock;

class RequiredOrderValidatorTest {

	private final RequiredOrderValidator validator = new RequiredOrderValidator();

	@Mock
	private RequiredOrder requiredOrder;

	@Mock
	private ConstraintValidatorContext constraintValidatorContext;

	@Nested
	class TestIsValid {
		private CommandOrder commandOrder = CommandOrder.VORGANG_ANNEHMEN;

		@BeforeEach
		void init() {
			when(requiredOrder.value()).thenReturn(commandOrder);
			validator.initialize(requiredOrder);
		}

		@Test
		void shouldReturnTrue() {
			var validationResult = validator.isValid(CommandTestFactory.createCreateCommandBuilder().order(commandOrder.name()).build(),
					constraintValidatorContext);

			assertThat(validationResult).isTrue();
		}

		@Test
		void shouldReturnFalse() {
			var validationResult = validator.isValid(
					CommandTestFactory.createCreateCommandBuilder().order(CommandOrder.ASSIGN_USER.name()).build(),
					constraintValidatorContext);

			assertThat(validationResult).isFalse();
		}
	}

}