package de.ozgcloud.alfa.historie;

import java.util.List;

import de.ozgcloud.alfa.common.command.CommandOrder;

class VorgangChangeHistoryTestFactory {

	public static final List<VorgangChange> STATUS_CHANGE_HISTORY = List.of(VorgangChangeTestFactory.createBuilder()
			.order(CommandOrder.VORGANG_ANNEHMEN.name()).build());
	public static final List<VorgangChange> AKTENZEICHEN_CHANGE_HISTORY = List.of(VorgangChangeTestFactory.createBuilder()
			.order(CommandOrder.SET_AKTENZEICHEN.name()).build());
	public static final List<VorgangChange> ASSIGNED_USER_CHANGE_HISTORY = List.of(VorgangChangeTestFactory.createBuilder()
			.order(CommandOrder.ASSIGN_USER.name()).build());

	public static VorgangChangeHistory create() {
		return VorgangChangeHistory.builder()
				.statusChangeHistory(STATUS_CHANGE_HISTORY)
				.aktenzeichenChangeHistory(AKTENZEICHEN_CHANGE_HISTORY)
				.assignedUserChangeHistory(ASSIGNED_USER_CHANGE_HISTORY)
				.build();
	}

}
