package de.ozgcloud.alfa.resource;

import static de.ozgcloud.alfa.resource.OzgcloudResourceController.*;
import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.springframework.hateoas.EntityModel;
import org.springframework.hateoas.IanaLinkRelations;
import org.springframework.hateoas.Link;

class OzgcloudResourceModelAssemblerTest {

	@InjectMocks
	private OzgcloudResourceModelAssembler assembler;

	@Nested
	class TestToModel {

		private final OzgcloudResourceURIResolveResult uriResolveResult = OzgcloudResourceURIResolveResultTestFactory.create();

		@Test
		void shouldHaveSelfLink() {
			var model = callAssembler();

			assertThat(model.getLink(IanaLinkRelations.SELF_VALUE)).isPresent().get().extracting(Link::getHref)
					.isEqualTo(OzgcloudResourceController.PATH + "?" + PARAM_URI + "=" + OzgcloudResourceURIResolveResultTestFactory.ENCODED_RESOURCE_URI);
		}

		@Test
		void shouldHaveResourceLink() {
			var model = callAssembler();

			assertThat(model.getLink(OzgcloudResourceURIResolveResultTestFactory.RESOURCE_LINK.getRel())).isPresent().get().isEqualTo(
					OzgcloudResourceURIResolveResultTestFactory.RESOURCE_LINK);
		}

		private EntityModel<OzgcloudResource> callAssembler() {
			return assembler.toModel(uriResolveResult);
		}
	}
}
