package de.ozgcloud.alfa.resource;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.springframework.hateoas.EntityModel;
import org.springframework.hateoas.Link;

import de.ozgcloud.alfa.Root;
import de.ozgcloud.alfa.RootTestFactory;

class OzgcloudResourceRootProcessorTest {

	private final OzgcloudResourceRootProcessor processor = new OzgcloudResourceRootProcessor();

	@Nested
	class TestProcess {

		private final EntityModel<Root> model = EntityModel.of(RootTestFactory.create());

		@Test
		void shouldReturnOriginalModel() {
			var result = processor.process(model);

			assertThat(result).isEqualTo(model);
		}

		@Test
		void shouldAddResourceLink() {
			processor.process(model);

			assertThat(model.getLink(OzgcloudResourceRootProcessor.REL_RESOURCE)).isPresent().get().extracting(Link::getHref)
					.isEqualTo(OzgcloudResourceController.PATH + "?uri={uri}");
		}
	}
}


